<template>
  <div id="testPaperManagement">
    <search-box-new
      ref="searchBox"
      :formData="formData"
      :formList="formList"
      @search="search"
      @init="init"
    />
    <table-list
      :tableSets="tableSet"
      :tableData="tableData"
      :navText="navText"
      @addClick="addClick"
      :loading="loading"
      @editInfo="editInfo"
      ref="tableList"
      rowKey="examId"
    >
      <template slot="customize">
        <el-button size="medium" @click="batchDel" type="warning"
          >批量删除</el-button
        >
      </template>
      <template slot="btn" slot-scope="props">
        <el-button type="text" @click="addClick(props.scope.row, 1)"
          >基本信息</el-button
        >
        <el-button type="text" @click="addClick(props.scope.row, 2)"
          >题目内容</el-button
        >
        <el-button type="text" @click="preview(props.scope.row.examId)"
          >预览</el-button
        >
        <el-button type="text" @click="del(props.scope.row)">删除</el-button>
      </template>
    </table-list>
    <pagination
      :total="total"
      :pageSize="formData.pageSize"
      :currentPage="formData.pageNum"
      @handleSizeChange="handleSizeChange"
      @handleCurrentChange="handleCurrentChange"
    />
    <test-paper-preview ref="testPaperPreview" />
  </div>
</template>

<script>
import searchBoxNew from "@/components/searchBoxNew";
import tableList from "@/components/tableList";
import pagination from "@/components/pagination";
import testPaperPreview from "@/components/testPaperPreview";
import { paperBatchDel } from "@/api/resource/volumeManagement";
export default {
  name: "TestPaperManagement",
  components: { tableList, pagination, searchBoxNew, testPaperPreview },
  data() {
    return {
      loading: false, //当前表单加载是否加载动画
      navText: {
        title: "试卷管理",
        index: 0,
        ch: "条",
        num: true,
        border: true,
        choice: true,
        changeWidth: "240px",
        addHide: false,
        openCheckMore: true,
        backFatherBtn: {
          status: false,
          title: "未定义",
        },
      },
      //搜索
      formList: [
        {
          prop: "educationTypeId",
          placeholder: "教育类型",
          scope: "educationType",
        },
        {
          prop: "businessId",
          placeholder: "业务层次",
          scope: "businessLevel",
          edu: "educationTypeId",
        },
        {
          prop: "subjectId",
          placeholder: "科目",
          scope: "sujectType",
          edu: "educationTypeId",
        },
        {
          prop: "publishStatus",
          placeholder: "发布状态",
          scope: "select",
          options: [
            {
              label: "发布",
              value: 1,
            },
            {
              label: "未发布",
              value: 0,
            },
          ],
        },
        {
          prop: "prefixName",
          placeholder: "请输入名称前缀",
        },
        {
          prop: "examName",
          placeholder: "请输入试卷名称",
        },
      ],
      formData: {
        status: "0,1",
        pageSize: 10,
        pageNum: 1,
      },
      // 表单
      tableSet: [
        {
          label: "试卷编码",
          prop: "code",
          hidden: false,
        },
        {
          label: "名称前缀",
          prop: "prefixName",
          hidden: false,
        },
        {
          label: "试卷名称",
          prop: "examName",
          hidden: true,
          scope: "editInfo",
        },
        {
          label: "试卷类型",
          prop: "paperName",
          hidden: true
        },
        {
          label: "适用业务层级",
          prop1: "educationName",
          prop2: "projectName",
          prop3: "businessName",
          prop4: "subjectName",
          hidden: false,
          scope: "eduTypes",
        },
        {
          label: "发布状态",
          prop: "publishStatus",
          hidden: true,
          scope: "fabStatus",
        },
        {
          label: "最后编辑时间",
          prop: "updateTime",
          hidden: true,
          scope: "aTimeList",
        },
        {
          label: "创建时间",
          prop: "createTime",
          hidden: true,
          scope: "aTimeList",
        },
        {
          label: "关联商品",
          prop: "goodsList",
          prop1: "goodsName",
          hidden: false,
          scope: "aboutChapter",
          int: 6,
        },
      ],
      tableData: [], //表单数据
      total: 0, //一共多少条
    };
  },
  mounted() {
    this.search();
  },
  activated() {
    this.search();
  },
  methods: {
    batchDel() {
      if (!this.$refs.tableList.allCheckData.length) {
        this.$message.warning("请勾选需要删除的试卷");
        return;
      }
      this.$confirm(
        `此操作将永久删除所勾选的${this.$refs.tableList.allCheckData.length}条试卷, 是否继续?`,
        "提示",
        {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        }
      )
        .then(() => {
          const ids = this.$refs.tableList.allCheckData.map(
            (item) => item.examId
          );
          paperBatchDel({
            status: -1,
            ids,
          }).then((res) => {
            this.$message.success("批量删除成功");
            this.$refs.tableList.clearMoreActive();
            this.search(1);
          });
        })
        .catch(() => {});
    },
    preview(id) {
      this.$refs.testPaperPreview.openBox(1, id);
    },
    editInfo(v) {
      this.addClick(v, 1);
    },
    search(int) {
      this.loading = true;
      if (int === 1) {
        this.formData.pageNum = 1;
      }
      if (int === 2) {
        this.formData = {
          status: "0,1",
          pageSize: 10,
          pageNum: 1,
        };
      }
      this.$api
        .inquirebankexamList(this.formData)
        .then((res) => {
          this.tableData = res.rows;
          this.total = res.total;
          this.navText.index = res.total;
        })
        .finally(() => {
          this.loading = false;
        });
    },
    init() {
      this.search(2);
    },
    del(v) {
      this.$api.gradecheckGoodsChange({ examId: v.examId }).then((res) => {
        if (res.data > 0) {
          this.$message.error("已有学员正在学习，无法删除");
          return;
        } else {
          this.$alert(
            "确定删除此内容？<br />内容删除后将无法恢复，请慎重考虑",
            "提示",
            {
              dangerouslyUseHTMLString: true,
            }
          )
            .then(() => {
              var data = {
                examId: v.examId,
                status: -1,
              };
              this.$api.editbankexam(data).then((res) => {
                this.$message.success("删除成功");
                this.search();
              });
            })
            .catch(() => {
              this.$message({
                type: "info",
                message: "已取消删除",
              });
            });
        }
      });
    },
    addClick(v, int) {
      if (v === undefined) {
        this.$router.push({
          path: "AddPaper",
        });
        return;
      }
      if (int === 1 || int === 2) {
        const jump = () => {
          this.$store.dispatch("changetestPaperPage", null);
          this.$router.push({
            path: "editPaper",
            query: {
              id: v.examId,
              code: v.code,
              name: int,
            },
          });
        };
        const statusPage = this.$store.state.tagsView.visitedViews.some(
          (item) => {
            return item.name == "EditPaper";
          }
        );
        if (statusPage) {
          this.$store
            .dispatch("tagsView/delCachedView", {
              name: "EditPaper",
            })
            .then((res) => {
              jump();
            });
        } else {
          jump();
        }
        return;
      }
    },
    handleSizeChange(v) {
      this.formData.pageSize = v;
      this.formData.pageNum = 1;
      this.search();
    },
    handleCurrentChange(v) {
      this.formData.pageNum = v;
      this.search();
    },
  },
};
</script>

<style lang="less" scoped>
/deep/.el-button {
  border-radius: 8px;
}
/deep/.el-dialog {
  border-radius: 8px;
  .el-dialog__header {
    padding: 0;
    .hearders {
      height: 40px;
      display: flex;
      align-items: center;
      justify-content: space-between;
      padding: 0px 18px 0px 20px;
      border-bottom: 1px solid #e2e2e2;
      .leftTitle {
        font-size: 14px;
        font-weight: bold;
        color: #2f4378;
      }
      .rightBoxs {
        display: flex;
        align-items: center;
        img {
          width: 14px;
          height: 14px;
          margin-left: 13px;
          cursor: pointer;
        }
      }
    }
  }
  .el-dialog__footer {
    padding: 0;
    .dialog-footer {
      padding: 0px 40px;
      height: 70px;
      border-top: 1px solid #e2e2e2;
      display: flex;
      align-items: center;
      justify-content: flex-end;
    }
  }
}
.imgBox {
  width: 100%;
  // height: 210px;
  border: 1px solid #e2e2e2;
  border-radius: 8px;
  padding: 8px 8px 3px;
  display: flex;
  flex-direction: column;
  align-items: center;
  .imgLabel {
    flex: 1;
    width: 100%;
    border: 1px dotted #e2e2e2;
    color: #999;
    font-size: 14px;
    cursor: pointer;
    border-radius: 8px;
    .msPhoto {
      display: flex;
      justify-content: center;
      align-items: center;
      max-width: 100%;
      max-height: 270px;
      img {
        max-width: 100%;
        max-height: 270px;
      }
    }
    .imgbbx {
      display: flex;
      flex-direction: column;
      align-items: center;
      justify-content: center;
      width: 100%;
      height: 100%;
      i {
        font-weight: bold;
        margin: 14px 0;
        font-size: 24px;
      }
    }
  }
  p {
    margin: 5px 0px;
  }
}
</style>